#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>

#define int long long

using namespace std;
using ll = long long;

const int INF = 1e12 + 228;

struct SegTree {
	int n;
	vector<int> t;

	SegTree(int n) : n(n), t(2 * n, INF) {}

	void upd(int v, int x) {
		v += n;
		t[v] = min(t[v], x);
		for (v >>= 1; v; v >>= 1) {
			t[v] = min(t[v << 1], t[v << 1 | 1]);
		}
	}

	int get(int l, int r) {
		int ret = INF;
		for (l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
			if (l & 1) {
				ret = min(ret, t[l]);
			}
			if (!(r & 1)) {
				ret = min(ret, t[r]);
			}
		}
		return ret;
	}
};

struct Kek {
	int a, b, i;
};

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	vector<Kek> a(n);
	vector<int> keks;
	for (int i = 0; i < n; i++) {
		auto& x = a[i];
		cin >> x.a >> x.b;
		x.i = i;
		keks.push_back(x.b);
	}
	sort(a.begin(), a.end(), [&](Kek a, Kek b) { return a.a < b.a; });
	sort(keks.begin(), keks.end());
	keks.erase(unique(keks.begin(), keks.end()), keks.end());
	vector<int> ans(n, INF);
	int mx = -INF;
	for (int i = n - 1; i >= 0; i--) {
		ans[a[i].i] = min(ans[a[i].i], max(0LL, a[i].b - mx));
		mx = max(mx, a[i].b);
	}
	SegTree t(keks.size());
	SegTree t1(keks.size());
	for (auto kek : a) {
		int pos = lower_bound(keks.begin(), keks.end(), kek.b) - keks.begin();
		ans[kek.i] = min(ans[kek.i], kek.a + t.get(pos, keks.size() - 1));
		ans[kek.i] = min(ans[kek.i], kek.a + kek.b + t1.get(0, pos));
		t.upd(pos, -kek.a);
		t1.upd(pos, -kek.a - kek.b);
	}
	for (auto x : ans) {
		cout << x << ' ';
	}
}