#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;

struct rect {
    int no;
    ll a, b;
};

int main() {

    int n;
    cin >> n;
    vector<rect> ra, rb;
    for (int i = 0; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        ra.push_back({i, a, b});
        rb.push_back(ra.back());
    }

    sort(ra.begin(), ra.end(), [](rect &p1, rect &p2) {
        return p1.a == p2.a ? p1.b < p2.b : p1.a < p2.a;
    });
    sort(rb.begin(), rb.end(), [](rect &p1, rect &p2) {
        return p1.b == p2.b ? p1.a < p2.a : p1.b < p2.b;
    });
    vector<int> posa(n);
    vector<ll> sufa(n + 1), sufb(n + 1);
    sufa[n] = sufb[n] = -1;
    for (int i = n - 1; i > -1; i--) {
        posa[ra[i].no] = i;
        sufa[i] = max(sufa[i + 1], ra[i].b);
        sufb[i] = max(sufb[i + 1], rb[i].a);
    }

    vector<ll> result(n);
    for (int i = 0; i < n; i++) {
        ll res = 4'000'000'000ll;
        if (i < n - 1) {
            ll maxa_right = sufb[i + 1];
            res = min(res, max(0ll, rb[i].a - maxa_right));
        }
        if (posa[rb[i].no] < n - 1) {
            ll maxb_right = sufa[posa[rb[i].no] + 1];
            res = min(res, max(0ll, rb[i].b - maxb_right));
        }
        result[rb[i].no] = res;
    }

    for (ll res : result)
        cout << res << ' ';
    cout << '\n';

}