#include "testlib.h"

using namespace std;

typedef long long ll;

int check(ll B, vector<ll> const &a, InStream &in) {
    int n2 = a.size();
    int t = in.readInt(0, n2, "t");
    vector<int> h = in.readInts(n2, 1, n2, "h");
    for (int i = 0; i < n2 / 2; i++) {
        in.ensuref(h[2 * i] != h[2 * i + 1], "symbiotes %d and %d reside in same host", 2 * i + 1, 2 * i + 2);
    }

    vector<ll> total(n2);
    set<int> hosts;
    for (int i = 0; i < n2; i++) {
        int hi = h[i] - 1, hp = hi / 2, ip = i / 2;
        in.ensuref(hp == ip - 1 || hp == ip, "symbiote %d can't reside in host %d", i + 1, hi + 1);
        hosts.insert(hi);

        total[hi] += a[i];
        in.ensuref(total[hi] <= B, "symbiote %d doesn't fit into host %d, not enough capacity %lld < %lld",
                i + 1, hi + 1, B, total[hi]);
    }

    in.ensuref(hosts.size() == t, "expected %d hosts to be used, but %d were used instead", t, hosts.size());
    return t;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    ll B = inf.readInt();
    vector<ll> a = inf.readLongs(2 * n);

    int ja = check(B, a, ans), pa = check(B, a, ouf);
    if (ja > pa)
        quitf(_fail, "participant has a better answer %d than jury's %d", pa, ja);
    if (ja < pa)
        quitf(_wa, "jury has a better answer %d than participant's %d", ja, pa);

    quitf(_ok, "all checks passed");

}