#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (int i = 0; i < v.size(); i++)
        in >> v[i];
    return in;
}

int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    ll B;
    cin >> n >> B;
    vector<ll> a(2 * n);
    cin >> a;
    auto c1 = [B](ll x) {
        return x <= B;
    };
    auto c2 = [B](ll x, ll y) {
        return x <= B && y <= B;
    };

    ll px = a[0], py = a[1];
    int pl = 0, pr = 1;
    if (px < py) {
        swap(px, py);
        swap(pl, pr);
    }
    vector<int> h(2 * n);
    h[1] = 1;

    for (int i = 1; i < n; i++) {
        ll x = a[2 * i], y = a[2 * i + 1];
        int l = 2 * i, r = 2 * i + 1;
        if (x < y) {
            swap(x, y);
            swap(l, r);
        }

        if (c2(px + y, py + x)) {
            h[l] = pr;
            h[r] = pl;
            px = py = 0;
        } else if (c1(py + x)) {
            h[l] = pr;
            h[r] = l;
            px = y; py = 0;
        } else if (c1(py + y)) {
            h[l] = l;
            h[r] = pr;
            px = x; py = 0;
        } else {
            h[l] = l;
            h[r] = r;
            px = x; py = y;
        }

        pl = l;
        pr = r;
    }

    cout << unordered_set<int>(h.begin(), h.end()).size() << '\n';
    for (int hi : h) {
        cout << hi + 1 << ' ';
    }
    cout << '\n';

}