#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (int i = 0; i < v.size(); i++)
        in >> v[i];
    return in;
}

int main() {

    int n;
    ll B;
    cin >> n >> B;
    vector<ll> a(2 * n);
    cin >> a;
    for (ll ai: a) {
        if (ai > B) {
            cout << 0 << '\n';
            return 0;
        }
    }

    const ll p = 1000'000'007;
    vector<vector<ll>> dp(n, vector<ll>(5));
    // (0,0), (0,1) x2, (0,2) x2, (1,2) x2, (0,1+2) x2
    dp[0][3] = 2;
    if (a[0] + a[1] <= B)
        dp[0][4] = 2;

    auto c1 = [B](int x) {
        return x <= B;
    };
    auto c2 = [B](int x, int y) {
        return x <= B && y <= B;
    };

    for (int i = 1; i < n; i++) {
        ll x = a[2 * i], y = a[2 * i + 1];
        ll px = a[2 * i - 2], py = a[2 * i - 1];
        int both = c1(x + y);

        dp[i][0] += dp[i - 1][0] * 2 * (1 + both);
        dp[i][0] += dp[i - 1][1] * (both + c1(x + px) + c1(y + px) + c1(x + y + px));
        dp[i][0] += dp[i - 1][2] * (both + c1(x + py) + c1(y + py) + c1(x + y + py));
        dp[i][0] += dp[i - 1][3] * (c2(x + px, y + py) + c2(x + py, y + px) + c1(x + y + px) + c1(x + y + py));
        dp[i][0] += dp[i - 1][4] * (both + c1(x + px + py) + c1(y + px + py) + c1(x + y + px + py));

        dp[i][1] += dp[i - 1][0] * 4;
        dp[i][1] += dp[i - 1][1] * 2 * (1 + c1(px + y));
        dp[i][1] += dp[i - 1][2] * 2 * (1 + c1(py + y));
        dp[i][1] += dp[i - 1][3] * 2 * (c1(px + y) + c1(py + y));
        dp[i][1] += dp[i - 1][4] * 2 * (1 + c1(px + py + y));

        dp[i][2] += dp[i - 1][0] * 4;
        dp[i][2] += dp[i - 1][1] * 2 * (1 + c1(px + x));
        dp[i][2] += dp[i - 1][2] * 2 * (1 + c1(py + x));
        dp[i][2] += dp[i - 1][3] * 2 * (c1(px + x) + c1(py + x));
        dp[i][2] += dp[i - 1][4] * 2 * (1 + c1(px + py + x));

        dp[i][3] += 2 * (dp[i - 1][0] +
                         dp[i - 1][1] +
                         dp[i - 1][2] +
                         dp[i - 1][3] +
                         dp[i - 1][4]);

        dp[i][4] = both ? dp[i][3] : 0;

        for (int t = 0; t < 5; t++)
            dp[i][t] %= p;
    }

    cout << (dp[n - 1][0] + dp[n - 1][1] + dp[n - 1][2] + dp[n - 1][3] + dp[n - 1][4]) % p << '\n';

}