#include "testlib.h"

using namespace std;
int n, m;
vector<int> a, b;

int check(InStream& in) {
    string s = in.readWord();

    if (s == "NO") {

        if (!in.seekEof()) {
            in.quitf(_wa, "EOF expected");
        }

        return -1;
    } else if (s == "YES") {

        vector<int> v(n);
        for (int i = 0; i < n; ++i) {
            v[i] = in.readInt();
            if (i && v[i] <= v[i - 1]) {
                in.quitf(_wa, "not subsequence");
            }
        }
        if (!in.seekEof()) {
            in.quitf(_wa, "EOF expected");
        }

        for (int i = 0; i < n; i++) {
            if (b[v[i] - 1] - b[v[0] - 1] != a[i] - a[0]) {
                in.quitf(_wa, "invalid subsequence");
            }
        }
        int j = 0;
        for (int i = v[0] - 1; i < v.back(); i++) {
            if (i == v[j] - 1) {
                j++;
            } else {
                if (b[i] > b[v[0] - 1] - a[0]) {
                    in.quitf(_wa, "invalid subsequence %");
                }
            }
        }
        return 1;
    } else {
        in.quitf(_wa, "invalid input");
    }
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
    }
    m = inf.readInt();
    b.resize(m);
    for (int i = 0; i < m; i++) {
        b[i] = inf.readInt();
    }

    int paScore = check(ouf);
    int jaScore = check(ans);

    if (paScore == jaScore) {
        quitf(_ok, "OK");
    } else if (paScore < jaScore) {
        quitf(_wa, "Participant's score is not optimal");
    } else {
        quitf(_fail, "Jury's score is not optimal");
    }
    return 0;
}
