#include "testlib.h"

using namespace std;

vector<int> check(vector<int> &a, InStream &in) {
    vector<int> res;
    int i = in.readInt(1, a.size(), "result") - 1;
    int start = a[i];
    for (int j = 0; j < a.size(); j++) {
        int idx = (start + j) % a.size();
        if (idx != i)
            res.push_back(a[idx]);
    }
    in.ensuref(res.size() == a.size() - 1, "expected answer size %d, got %d", a.size() - 1, res.size());
    return res;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<int> a = inf.readInts(n);

    vector<int> ja = check(a, ans), pa = check(a, ouf);
    for (int i = 0; i < n - 1; i++) {
        if (ja[i] > pa[i])
            quitf(_fail, "participant has better answer: %d on position %d instead of %d", pa[i], i + 1, ja[i]);
        if (pa[i] > ja[i])
            quitf(_wa, "jury has better answer: %d on position %d instead of %d", ja[i], i + 1, pa[i]);
    }

    quitf(_ok, "all checks passed");

}