#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &item: v)
        in >> item;
    return in;
}

int main() {

    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> b(a.begin(), a.end());
    for (int item: a) {
        b.push_back(item);
    }

    int m = 2 * n;
    vector<int> p(m), cnt(n);
    vector<vector<int>> c;
    c.emplace_back(m);
    for (int i = 0; i < m; i++)
        cnt[b[i]]++;
    for (int i = 1; i < n; i++)
        cnt[i] += cnt[i - 1];
    for (int i = 0; i < m; ++i)
        p[--cnt[b[i]]] = i;
    c[0][p[0]] = 0;
    int classes = 1;
    for (int i = 1; i < m; ++i) {
        if (b[p[i]] != b[p[i - 1]]) ++classes;
        c[0][p[i]] = classes - 1;
    }

    vector<int> pn(m, 0);
    for (int h = 0; (1 << h) < m; h++) {
        for (int i = 0; i < m; i++) {
            pn[i] = p[i] - (1 << h);
            if (pn[i] < 0) pn[i] += m;
        }
        cnt.assign(classes, 0);
        for (int i = 0; i < m; i++)
            cnt[c[h][pn[i]]]++;
        for (int i = 1; i < classes; i++)
            cnt[i] += cnt[i - 1];
        for (int i = m - 1; i >= 0; i--)
            p[--cnt[c[h][pn[i]]]] = pn[i];
        c.emplace_back(m);
        c[h + 1][p[0]] = 0;
        classes = 1;
        for (int i = 1; i < m; i++) {
            int mid1 = (p[i] + (1 << h)) % m, mid2 = (p[i - 1] + (1 << h)) % m;
            if (c[h][p[i]] != c[h][p[i - 1]] || c[h][mid1] != c[h][mid2])
                classes++;
            c[h + 1][p[i]] = classes - 1;
        }
    }

    vector<int> log2(m + 1, 0);
    for (int i = 2; i <= m; i++) {
        log2[i] = log2[i / 2] + 1;
    }

    auto compare = [&c, &log2](int i, int j, int sz) {
        if (sz == 0) return 0;
        int k = log2[sz];
        pair<int, int> a(c[k][i], c[k][i + sz - (1 << k)]);
        pair<int, int> b(c[k][j], c[k][j + sz - (1 << k)]);
        return a == b ? 0 : a < b ? -1 : 1;
    };

    vector<int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = i;
    }
    vector<int> b1, b2;
    sort(res.begin(), res.end(), [&](int i, int j) {
        int s1 = a[i], s2 = a[j];
        int p1 = (i + n - s1) % n, p2 = (j + n - s2) % n;
        if (p1 < p2) {
            int comp = compare(s1, s2, p1);
            if (comp != 0) return comp < 0;
            comp = compare((s1 + p1 + 1) % n, (s2 + p1) % n, p2 - p1);
            if (comp != 0) return comp < 0;
            return compare((s1 + p2 + 1) % n, (s2 + p2 + 1) % n, n - p2 - 1) < 0;
        } else {
            int comp = compare(s1, s2, p2);
            if (comp != 0) return comp < 0;
            comp = compare((s1 + p2) % n, (s2 + p2 + 1) % n, p1 - p2);
            if (comp != 0) return comp < 0;
            return compare((s1 + p1 + 1) % n, (s2 + p1 + 1) % n, n - p1 - 1) < 0;
        }
    });

    cout << res[0] + 1 << '\n';

}