#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

#define sqr(a) (a)*(a)
#define ll long long

ll pifagor(const pair<int, int> &x, const pair<int, int> &y) {
    return sqr((ll) x.first - (ll) y.first) + sqr((ll) x.second - (ll) y.second);
}

const int max_nm = 10000000;

bool user_g_dfs(const vector<vector<int>> &g, vector<bool> &used, int v) {
    bool bad = false;
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (const auto e : g[v]) {
        bad = bad || user_g_dfs(g, used, e);
    }

    return bad;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int m = inf.readInt();

    vector<pair<int, int>> source(n);
    vector<pair<int, int>> user(m);
    for (int i = 0; i < n; ++i) {
        source[i].first = inf.readLong();
        source[i].second = inf.readLong();
    }

    for (int i = 0; i < m; ++i) {
        user[i].first = inf.readLong();
        user[i].second = inf.readLong();
    }

    ll pa = ouf.readLong();
    int pa_cnt = ouf.readInt(0, max_nm, "count_of_edges_in_answer");
    ll ja = ans.readLong();
    int ja_cnt = ans.readInt();

    if (pa > ja || ja_cnt < pa_cnt) {
        quitf(_wa, "jury answer lower then participant's answer");
    }
    if (ja_cnt > pa_cnt) {
        quitf(_wa, "jury answer grater then participant's answer");
    }

    vector<pair<int, int>> s_to_u, u_to_u;
    int main_user;
    ll sum_ans = 0;

    for (int q = 0; q < pa_cnt; ++q) {
        string t1 = ouf.readToken();
        if (t1 != "s" && t1 != "u") {
            quitf(_wa, "unexpected type [%s] of first point for edge %d", t1.c_str(), q + 1);
        }
        int x, y;
        if (t1 == "s") {
            x = ouf.readInt(1, n) - 1;
        } else {
            x = ouf.readInt(1, m) - 1;
        }
        ouf.readToken("->");
        y = ouf.readInt(1, m) - 1;
        if (t1 == "s") {
            s_to_u.emplace_back(x, y);
            main_user = y;
        } else {
            u_to_u.emplace_back(x, y);
        }
    }

    vector<bool> s_to_u_exist(n);
    for (const auto &edge : s_to_u) {
        if (edge.second != main_user) {
            quitf(_wa, "Edge source to use go to not general user: s%d -> u%d", edge.first, edge.second);
        }
        sum_ans += pifagor(source[edge.first], user[edge.second]);
        s_to_u_exist[edge.first] = true;
    }

    for (int i = 0; i < n; ++i) {
        if (!s_to_u_exist[i]) {
            quitf(_wa, "no edge from source %d to user", i);
        }
    }

    vector<vector<int>> user_g(m);

    for (const auto &edge : u_to_u) {
        sum_ans += pifagor(user[edge.first], user[edge.second]);
        user_g[edge.first].push_back(edge.second);
    }

    vector<bool> user_g_used(m);
    bool bad = user_g_dfs(user_g, user_g_used, main_user);
    if (bad) {
        quitf(_wa, "users graph is not tree");
    }
    for (int i = 0; i < m; ++i) {
        if (!user_g_used[i]) {
            quitf(_wa, "no edge from any source to user %d", i);
        }
    }

    if (pa != sum_ans) {
        quitf(_wa, "participant's graph weight is %lld, but participant say %lld", sum_ans, pa);
    }
    if (pa < ja) {
        quitf(_fail, "jury answer grater then participant's answer ans participant's is correct");
    }


    quitf(_ok, "%lld", pa);
}