using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

pair<int, int> gen_coordinates(const ll max_coords, unordered_map<ll, unordered_set<ll>> &used_c) {
    while (true) {
        ll x = rnd.next(-max_coords, max_coords);
        ll y = rnd.next(-max_coords, max_coords);
        if (used_c.find(x) == used_c.end() || used_c[x].find(y) == used_c[x].end()) {
            return make_pair(x, y);
        }
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");
    ll max_coords = opt<ll>("c");
    ll hard_mode = opt<bool>("hard");

    int n, m;
    if (!hard_mode) {
        n = rnd.next(1, max_n);
        m = rnd.next(1, max_m);
    } else {
        n = rnd.next(max_n / 4 * 3, max_n);
        m = rnd.next(max_m / 4 * 3, max_m);
    }

    cout << n << " " << m << endl;

    unordered_map <ll, unordered_set<ll>> used_c;


    for (int i = 0; i < n + m; ++i) {
        auto p = gen_coordinates(max_coords, used_c);
        cout << p.first << " " << p.second << endl;
    }

    return 0;
}
