#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
using P = pair<ll, ll>;

ll dist(P a, P b) {
    return ((ll) a.first - b.first) * ((ll) a.first - b.first) +
           ((ll) a.second - b.second) * ((ll) a.second - b.second);
}

struct Kek {
    char tp;
    int from, to;
};

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<P> a(n), b(m);
    for (auto &p : a) {
        cin >> p.first >> p.second;
    }
    for (auto &p : b) {
        cin >> p.first >> p.second;
    }
    const ll INF = LLONG_MAX;
    pair<ll, int> lol = {INF, -1};
    for (int i = 0; i < m; i++) {
        ll kek = 0;
        for (int j = 0; j < n; j++) {
            ll d = dist(b[i], a[j]);
            kek += d;
        }
        lol = min(lol, {kek, i});
    }
    ll tot = lol.first;
    vector<Kek> ans;
    for (int c = 0; c < n; c++) {
        ans.push_back({'s', c, lol.second});
    }
    vector<ll> dst(m, INF);
    vector<bool> done(m);
    vector<int> pred(m, -1);
    dst[lol.second] = 0;
    for (int it = 0; it < m; it++) {
        int c = -1;
        for (int j = 0; j < m; j++) {
            if (!done[j] && (c == -1 || dst[j] < dst[c])) {
                c = j;
            }
        }
        if (c == -1) {
            break;
        }
        done[c] = true;
        for (int j = 0; j < m; j++) {
            if (!done[j]) {
                ll nd = dist(b[c], b[j]);
                if (nd < dst[j]) {
                    dst[j] = nd;
                    pred[j] = c;
                }
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (pred[i] != -1) {
            tot += dst[i];
            ans.push_back({'u', pred[i], i});
        }
    }
    cout << tot << '\n';
    cout << ans.size() << '\n';
    for (auto e : ans) {
        cout << e.tp << ' ' << e.from + 1 << " -> " << e.to + 1 << '\n';
    }
}